## openjpeg2 2.5.3

=== CMakeLists.txt ===
# Main CMakeLists.txt to build the OpenJPEG project using CMake (www.cmake.org)
# Written by Mathieu Malaterre

# This CMake project will by default create a library called openjpeg
# But if you want to use this project within your own (CMake) project
# you will eventually like to prefix the library to avoid linking confusion
# For this purpose you can define a CMake var: OPENJPEG_NAMESPACE to whatever you like
# e.g.:
# set(OPENJPEG_NAMESPACE "GDCMOPENJPEG")
cmake_minimum_required(VERSION 3.5)

if(NOT OPENJPEG_NAMESPACE)
  set(OPENJPEG_NAMESPACE "OPENJPEG")
  set(OPENJPEG_STANDALONE 1)
endif()
# In all cases:
#string(TOLOWER ${OPENJPEG_NAMESPACE} OPENJPEG_LIBRARY_NAME)
set(OPENJPEG_LIBRARY_NAME openjp2)

project(${OPENJPEG_NAMESPACE} C)

# Do full dependency headers.
include_regular_expression("^.*$")

#-----------------------------------------------------------------------------
# OPENJPEG version number, useful for packaging and doxygen doc:
set(OPENJPEG_VERSION_MAJOR 2)
set(OPENJPEG_VERSION_MINOR 5)
set(OPENJPEG_VERSION_BUILD 3)
set(OPENJPEG_VERSION
  "${OPENJPEG_VERSION_MAJOR}.${OPENJPEG_VERSION_MINOR}.${OPENJPEG_VERSION_BUILD}")
set(PACKAGE_VERSION
  "${OPENJPEG_VERSION_MAJOR}.${OPENJPEG_VERSION_MINOR}.${OPENJPEG_VERSION_BUILD}")

# Because autotools does not support X.Y notation for SOVERSION, we have to use
# two numbering, one for the openjpeg version and one for openjpeg soversion
# version | soversion
#   1.0   |  0
#   1.1   |  1
#   1.2   |  2
#   1.3   |  3
#   1.4   |  4
#   1.5   |  5
#   1.5.1 |  5
#   2.0   |  6
#   2.0.1 |  6
#   2.1   |  7
#   2.1.1 |  7
#   2.1.2 |  7
#   2.2.0 |  7
#   2.3.0 |  7
#   2.3.1 |  7
#   2.4.0 |  7
#   2.5.0 |  7
#   2.5.1 |  7
#   2.5.2 |  7
#   2.5.3 |  7
# above is the recommendation by the OPJ team. If you really need to override this default,
# you can specify your own OPENJPEG_SOVERSION at cmake configuration time:
# cmake -DOPENJPEG_SOVERSION:STRING=42 /path/to/openjpeg
if(NOT OPENJPEG_SOVERSION)
  set(OPENJPEG_SOVERSION 7)
endif(NOT OPENJPEG_SOVERSION)
set(OPENJPEG_LIBRARY_PROPERTIES
  VERSION   "${OPENJPEG_VERSION_MAJOR}.${OPENJPEG_VERSION_MINOR}.${OPENJPEG_VERSION_BUILD}"
  SOVERSION "${OPENJPEG_SOVERSION}"
)

# --------------------------------------------------------------------------
# Path to additional CMake modules
set(CMAKE_MODULE_PATH
    ${${OPENJPEG_NAMESPACE}_SOURCE_DIR}/cmake
    ${CMAKE_MODULE_PATH})

# --------------------------------------------------------------------------
# On Visual Studio 8 MS deprecated C. This removes all 1.276E1265 security
# warnings
if(WIN32)
  if(NOT BORLAND)
    if(NOT CYGWIN)
      if(NOT MINGW)
        if(NOT ITK_ENABLE_VISUAL_STUDIO_DEPRECATED_C_WARNINGS)
          add_definitions(
            -D_CRT_FAR_MAPPINGS_NO_DEPRECATE
            -D_CRT_IS_WCTYPE_NO_DEPRECATE
            -D_CRT_MANAGED_FP_NO_DEPRECATE
            -D_CRT_NONSTDC_NO_DEPRECATE
            -D_CRT_SECURE_NO_DEPRECATE
            -D_CRT_SECURE_NO_DEPRECATE_GLOBALS
            -D_CRT_SETERRORMODE_BEEP_SLEEP_NO_DEPRECATE
            -D_CRT_TIME_FUNCTIONS_NO_DEPRECATE
            -D_CRT_VCCLRIT_NO_DEPRECATE
            -D_SCL_SECURE_NO_DEPRECATE
            )
        endif()
      endif()
    endif()
  endif()
endif()


# --------------------------------------------------------------------------
# Install directories
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME)
include(GNUInstallDirs)

# Build DOCUMENTATION (not in ALL target and only if Doxygen is found)
option(BUILD_DOC "Build the HTML documentation (with doxygen if available)." OFF)

set(OPENJPEG_INSTALL_SUBDIR "${PROJECT_NAME}-${OPENJPEG_VERSION_MAJOR}.${OPENJPEG_VERSION_MINOR}")

if(NOT OPENJPEG_INSTALL_JNI_DIR)
  if(WIN32)
    set(OPENJPEG_INSTALL_JNI_DIR ${CMAKE_INSTALL_BINDIR})
  else()
    set(OPENJPEG_INSTALL_JNI_DIR ${CMAKE_INSTALL_LIBDIR})
  endif()
endif()

if(NOT OPENJPEG_INSTALL_PACKAGE_DIR)
  set(OPENJPEG_INSTALL_PACKAGE_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${OPENJPEG_INSTALL_SUBDIR}")
endif()

if (APPLE)
	option(OPJ_USE_DSYMUTIL "Call dsymutil on binaries after build." OFF)
endif()

#-----------------------------------------------------------------------------
# Big endian test:
if (NOT EMSCRIPTEN)
include (${CMAKE_ROOT}/Modules/TestBigEndian.cmake)
TEST_BIG_ENDIAN(OPJ_BIG_ENDIAN)
endif()

#-----------------------------------------------------------------------------
# Setup file for setting custom ctest vars
configure_file(
  ${${OPENJPEG_NAMESPACE}_SOURCE_DIR}/cmake/CTestCustom.cmake.in
  ${${OPENJPEG_NAMESPACE}_BINARY_DIR}/CTestCustom.cmake
  @ONLY
  )

#-----------------------------------------------------------------------------
# OpenJPEG build configuration options.
option(BUILD_SHARED_LIBS "Build OpenJPEG shared library and link executables against it." ON)
option(BUILD_STATIC_LIBS "Build OpenJPEG static library." ON)
set (EXECUTABLE_OUTPUT_PATH ${OPENJPEG_BINARY_DIR}/bin CACHE PATH "Single output directory for building all executables.")
set (LIBRARY_OUTPUT_PATH ${OPENJPEG_BINARY_DIR}/bin CACHE PATH "Single output directory for building all libraries.")
mark_as_advanced(LIBRARY_OUTPUT_PATH EXECUTABLE_OUTPUT_PATH)

#-----------------------------------------------------------------------------
# configure name mangling to allow multiple libraries to coexist
# peacefully
if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/openjpeg_mangle.h.in)
set(MANGLE_PREFIX ${OPENJPEG_LIBRARY_NAME})
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/openjpeg_mangle.h.in
               ${CMAKE_CURRENT_BINARY_DIR}/openjpeg_mangle.h
               @ONLY)
endif()

#-----------------------------------------------------------------------------
# Compiler specific flags:
if(CMAKE_COMPILER_IS_GNUCC)
  # For all builds, make sure openjpeg is std99 compliant:
  # set(CMAKE_C_FLAGS "-Wall -std=c99 ${CMAKE_C_FLAGS}") # FIXME: this setting prevented us from setting a coverage build.
  # Do not use ffast-math for all build, it would produce incorrect results, only set for release:
  set(OPENJPEG_LIBRARY_COMPILE_OPTIONS ${OPENJPEG_LIBRARY_COMPILE_OPTIONS} "$<$<CONFIG:Release>:-ffast-math>")
  set(OPENJP2_COMPILE_OPTIONS ${OPENJP2_COMPILE_OPTIONS} "$<$<CONFIG:Release>:-ffast-math>" -Wall -Wextra -Wconversion -Wunused-parameter -Wdeclaration-after-statement -Werror=declaration-after-statement -Wstrict-prototypes -Werror=strict-prototypes -Wmissing-prototypes -Werror=missing-prototypes)
endif()

#-----------------------------------------------------------------------------
# opj_config.h generation (1/2)

# Check if some include files are provided by the system
include(EnsureFileInclude)
# These files are mandatory
ensure_file_include("string.h"   HAVE_STRING_H   YES)
ensure_file_include("memory.h"   HAVE_MEMORY_H   YES)
ensure_file_include("stdlib.h"   HAVE_STDLIB_H   YES)
ensure_file_include("stdio.h"    HAVE_STDIO_H    YES)
ensure_file_include("math.h"     HAVE_MATH_H     YES)
ensure_file_include("float.h"    HAVE_FLOAT_H    YES)
ensure_file_include("time.h"     HAVE_TIME_H     YES)
ensure_file_include("stdarg.h"   HAVE_STDARG_H   YES)
ensure_file_include("ctype.h"    HAVE_CTYPE_H    YES)
ensure_file_include("assert.h"   HAVE_ASSERT_H   YES)
ensure_file_include("stdint.h"   HAVE_STDINT_H   YES)
ensure_file_include("inttypes.h" HAVE_INTTYPES_H YES)

# why check this one ? for openjpip ?
include (${CMAKE_ROOT}/Modules/CheckIncludeFile.cmake)
CHECK_INCLUDE_FILE("strings.h"      HAVE_STRINGS_H)
CHECK_INCLUDE_FILE("sys/stat.h"     HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILE("sys/types.h"    HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILE("unistd.h"       HAVE_UNISTD_H)

# Enable Large file support
include(TestLargeFiles)
OPJ_TEST_LARGE_FILES(OPJ_HAVE_LARGEFILES)

# Allocating Aligned Memory Blocks
include(CheckIncludeFiles)
check_include_files(malloc.h OPJ_HAVE_MALLOC_H)
include(CheckSymbolExists)
# _aligned_alloc https://msdn.microsoft.com/en-us/library/8z34s9c6.aspx
check_symbol_exists(_aligned_malloc malloc.h OPJ_HAVE__ALIGNED_MALLOC)
# posix_memalign (needs _POSIX_C_SOURCE >= 200112L on Linux)
set(CMAKE_REQUIRED_DEFINITIONS -D_POSIX_C_SOURCE=200112L)
check_symbol_exists(posix_memalign stdlib.h OPJ_HAVE_POSIX_MEMALIGN)
unset(CMAKE_REQUIRED_DEFINITIONS)
# memalign (obsolete)
check_symbol_exists(memalign malloc.h OPJ_HAVE_MEMALIGN)
#-----------------------------------------------------------------------------
# Build Library
if(BUILD_JPIP_SERVER)
  find_package(CURL REQUIRED)
  find_package(FCGI REQUIRED)
  find_package(Threads REQUIRED)
  if(NOT CMAKE_USE_PTHREADS_INIT)
    message(FATAL_ERROR "Only pthread are supported")
  endif()
endif()
add_subdirectory(src/lib)
option(BUILD_LUTS_GENERATOR "Build utility to generate t1_luts.h" OFF)
if(UNIX)
option(BUILD_UNIT_TESTS "Build unit tests (bench_dwt, test_sparse_array, etc..)" OFF)
endif()

#-----------------------------------------------------------------------------
# Build Applications
option(BUILD_CODEC "Build the CODEC executables" ON)
option(BUILD_JPIP "Build the JPIP library and executables." OFF)
if(BUILD_JPIP)
  option(BUILD_JPIP_SERVER "Build the JPIP server." OFF)
endif()
option(BUILD_VIEWER "Build the OPJViewer executable (C++)" OFF)
option(BUILD_JAVA "Build the openjpeg jar (Java)" OFF)
mark_as_advanced(BUILD_VIEWER)
mark_as_advanced(BUILD_JAVA)

if(BUILD_CODEC)
  # OFF: It will only build 3rd party libs if they are not found on the system
  # ON: 3rd party libs will ALWAYS be build, and used
  option(BUILD_THIRDPARTY "Build the thirdparty executables if it is needed" OFF)
  add_subdirectory(thirdparty)
  add_subdirectory(src/bin)
endif ()
add_subdirectory(wrapping)

#-----------------------------------------------------------------------------
# opj_config.h generation (2/2)
configure_file(
 ${CMAKE_CURRENT_SOURCE_DIR}/src/lib/openjp2/opj_config.h.cmake.in
 ${CMAKE_CURRENT_BINARY_DIR}/src/lib/openjp2/opj_config.h
 @ONLY
 )

 configure_file(
 ${CMAKE_CURRENT_SOURCE_DIR}/src/lib/openjp2/opj_config_private.h.cmake.in
 ${CMAKE_CURRENT_BINARY_DIR}/src/lib/openjp2/opj_config_private.h
 @ONLY
 )

#-----------------------------------------------------------------------------
# build documentation in doc subdir:
if(BUILD_DOC)
  add_subdirectory(doc)
endif()

#-----------------------------------------------------------------------------
# Build Testing
option(BUILD_TESTING "Build the tests." OFF)
if(BUILD_TESTING)
  if(BUILD_CODEC)
    enable_testing()
    include(CTest)

    # Search openjpeg data needed for the tests
    # They could be found via git on the OpenJPEG GitHub code project
    # git clone https://github.com/uclouvain/openjpeg-data.git
    find_path(OPJ_DATA_ROOT README-OPJ-Data
      PATHS $ENV{OPJ_DATA_ROOT} ${CMAKE_SOURCE_DIR}/../data
      NO_DEFAULT_PATH NO_CMAKE_FIND_ROOT_PATH
      )

    # Add repository where to find tests
    add_subdirectory(tests)

  else()
    message(FATAL_ERROR "You need build codec to run the tests")
  endif()
endif()

#-----------------------------------------------------------------------------
# install all targets referenced as OPENJPEGTargets (relocatable with CMake 3.0+)
install(EXPORT OpenJPEGTargets DESTINATION ${OPENJPEG_INSTALL_PACKAGE_DIR})
include(CMakePackageConfigHelpers)
configure_package_config_file(${CMAKE_CURRENT_LIST_DIR}/cmake/OpenJPEGConfig.cmake.in
  ${OPENJPEG_BINARY_DIR}/OpenJPEGConfig.cmake
  INSTALL_DESTINATION ${OPENJPEG_INSTALL_PACKAGE_DIR}
  PATH_VARS CMAKE_INSTALL_INCLUDEDIR)
write_basic_package_version_file(
  ${OPENJPEG_BINARY_DIR}/OpenJPEGConfigVersion.cmake
  COMPATIBILITY SameMajorVersion
  VERSION ${OPENJPEG_VERSION})
install(
  FILES
    ${OPENJPEG_BINARY_DIR}/OpenJPEGConfig.cmake
    ${OPENJPEG_BINARY_DIR}/OpenJPEGConfigVersion.cmake
  DESTINATION ${OPENJPEG_INSTALL_PACKAGE_DIR})

#-----------------------------------------------------------------------------

include (cmake/OpenJPEGCPack.cmake)

#-----------------------------------------------------------------------------
# pkgconfig support
macro(set_variable_from_rel_or_absolute_path var root rel_or_abs_path)

=== tests/conformance/CMakeLists.txt ===
# CONFORMANCE TESTS AND NON-REGRESSION ON THIS DATASET

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/Temporary)

set(TEMP ${CMAKE_CURRENT_BINARY_DIR}/Temporary)
set(BASELINE_CONF ${OPJ_DATA_ROOT}/baseline/conformance)
set(BASELINE_NR ${OPJ_DATA_ROOT}/baseline/nonregression)
set(INPUT_CONF ${OPJ_DATA_ROOT}/input/conformance)


# List of components by file (normally p0_13.j2k have 257 components but for this
#set of test we consider only 4)
set( CP0_nbC_list "not_used;1;1;1;3;4;4;3;3;1;3;1;1;4;3;1;1")
set( CP1_nbC_list "not_used;1;3;4;1;3;3;2")

set(COMMENTCODEVAR FALSE)


##--------------------------------------------------------------------------
## Tests about class 0 profile 0
## try to decode
## compare to ref file provided by the Executable Test Suite
## non regression comparison

## Parameters and tolerances given by Table C.1
#set( C0P0_ResFactor_list "not_used;0;0;0;3;3;3;0;5;2;0;0;0;0;2;0;0")
#set( C0P0_PEAK_list "not_used;0;0;0;33;54;109;10;7;4;10;0;0;0;0;0;0")
#set( C0P0_MSE_list "not_used;0;0;0;55.8;68;743;0.34;6.72;1.47;2.84;0;0;0;0;0;0")

#foreach(numFileC0P0 RANGE 1 16)

#  # Build filenames
#  if(${numFileC0P0} LESS 10)
#    set( filenameInput p0_0${numFileC0P0}.j2k )
#    set( filenameRef   c0p0_0${numFileC0P0}.pgx )
#  else()
#    set( filenameInput p0_${numFileC0P0}.j2k )
#    set( filenameRef   c0p0_${numFileC0P0}.pgx )
#  endif()

#  # Get corresponding tests parameters
#  list(GET C0P0_ResFactor_list ${numFileC0P0}  ResFactor)
#  #For Class-0 testing, we always focus on the first component only
#  #list(GET CP0_nbC_list ${numFileC0P0}  nbComponents)
#  set( nbComponents "1")
#  list(GET C0P0_PEAK_list ${numFileC0P0}  PEAK_limit)
#  list(GET C0P0_MSE_list ${numFileC0P0}  MSE_limit)

#  # Manage cases which need to try different resolution reduction
#  if (numFileC0P0 EQUAL 3 OR numFileC0P0 EQUAL 15)
#    get_filename_component(filenameRefSub ${filenameRef} NAME_WE)
#    #r = 0

#    add_test(ETS-C0P0-${filenameInput}-r0-decode
#        ${EXECUTABLE_OUTPUT_PATH}/opj_decompress
#        -i ${INPUT_CONF}/${filenameInput}
#        -o ${TEMP}/c0${filenameInput}-r0.pgx
#        -r 0
#        )

#    add_test(ETS-C0P0-${filenameInput}-r0-compare2ref
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_CONF}/${filenameRefSub}r0.pgx
#        -t ${TEMP}/c0${filenameInput}-r0.pgx
#        -n ${nbComponents}
#        -p ${PEAK_limit}
#        -m ${MSE_limit}
#        -s t_
#        )

#    set_tests_properties(ETS-C0P0-${filenameInput}-r0-compare2ref
#                         PROPERTIES DEPENDS
#                         ETS-C0P0-${filenameInput}-r0-decode)

#    add_test(NR-C0P0-${filenameInput}-r0-compare2base
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_NR}/opj_${filenameRefSub}-r0.pgx
#        -t ${TEMP}/c0${filenameInput}-r0.pgx
#        -n ${nbComponents}
#        -d
#        -s b_t_
#        )

#    set_tests_properties(NR-C0P0-${filenameInput}-r0-compare2base
#                         PROPERTIES DEPENDS
#                         ETS-C0P0-${filenameInput}-r0-decode)

#    #r = 1
#    add_test(ETS-C0P0-${filenameInput}-r1-decode
#        ${EXECUTABLE_OUTPUT_PATH}/opj_decompress
#        -i ${INPUT_CONF}/${filenameInput}
#        -o ${TEMP}/c0${filenameInput}-r1.pgx
#        -r 1
#        )

#    add_test(ETS-C0P0-${filenameInput}-r1-compare2ref
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_CONF}/${filenameRefSub}r1.pgx
#        -t ${TEMP}/c0${filenameInput}-r1.pgx
#        -n ${nbComponents}
#        -p ${PEAK_limit}
#        -m ${MSE_limit}
#        -s t_
#        )

#    set_tests_properties(ETS-C0P0-${filenameInput}-r1-compare2ref
#                         PROPERTIES DEPENDS
#                         ETS-C0P0-${filenameInput}-r1-decode)

#    add_test(NR-C0P0-${filenameInput}-r1-compare2base
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_NR}/opj_${filenameRefSub}-r1.pgx
#        -t ${TEMP}/c0${filenameInput}-r1.pgx
#        -n ${nbComponents}
#        -d
#        -s b_t_
#        )

#    set_tests_properties(NR-C0P0-${filenameInput}-r1-compare2base
#                         PROPERTIES DEPENDS
#                         ETS-C0P0-${filenameInput}-r1-decode)

#  else()

#    add_test(ETS-C0P0-${filenameInput}-decode
#        ${EXECUTABLE_OUTPUT_PATH}/opj_decompress
#        -i ${INPUT_CONF}/${filenameInput}
#        -o ${TEMP}/c0${filenameInput}.pgx
#        -r ${ResFactor}
#        )

#    add_test(ETS-C0P0-${filenameInput}-compare2ref
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_CONF}/${filenameRef}
#        -t ${TEMP}/c0${filenameInput}.pgx
#        -n ${nbComponents}
#        -p ${PEAK_limit}
#        -m ${MSE_limit}
#        -s t_
#        )

#    set_tests_properties(ETS-C0P0-${filenameInput}-compare2ref
#                         PROPERTIES DEPENDS
#                         ETS-C0P0-${filenameInput}-decode)

#    add_test(NR-C0P0-${filenameInput}-compare2base
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_NR}/opj_${filenameRef}
#        -t ${TEMP}/c0${filenameInput}.pgx
#        -n ${nbComponents}
#        -d
#        -s b_t_
#        )

#    set_tests_properties(NR-C0P0-${filenameInput}-compare2base
#                         PROPERTIES DEPENDS
#                         ETS-C0P0-${filenameInput}-decode)

#  endif()

#endforeach()

##--------------------------------------------------------------------------
## Tests about class 0 profile 1
## try to decode
## compare to ref file
## non regression comparison

## Parameters and tolerances given by Table C.4
#set( C0P1_ResFactor_list "not_used;0;3;3;0;4;1;0")
#set( C0P1_PEAK_list "not_used;0;35;28;2;128;128;0")
#set( C0P1_MSE_list "not_used;0;74;18.8;0.550;16384;16384;0")

#foreach(numFileC0P1 RANGE 1 7)

#  # Build filenames
#  set( filenameInput p1_0${numFileC0P1}.j2k )
#  set( filenameRef   c0p1_0${numFileC0P1}.pgx )

#  # Get corresponding tests parameters
#  list(GET C0P1_ResFactor_list ${numFileC0P1}  ResFactor)
#  #For Class-0 testing, we always focus on the first component only
#  #list(GET CP0_nbC_list ${numFileC0P0}  nbComponents)
#  set( nbComponents "1")
#  list(GET C0P1_PEAK_list ${numFileC0P1}  PEAK_limit)
#  list(GET C0P1_MSE_list ${numFileC0P1}  MSE_limit)

#  # Manage cases which need to try different resolution reduction
#  if (numFileC0P1 EQUAL 4 )
#    get_filename_component(filenameRefSub ${filenameRef} NAME_WE)

#    #r = 0
#    add_test(ETS-C0P1-${filenameInput}-r0-decode
#        ${EXECUTABLE_OUTPUT_PATH}/opj_decompress
#        -i ${INPUT_CONF}/${filenameInput}
#        -o ${TEMP}/c0${filenameInput}-r0.pgx
#        -r 0
#        )

#    add_test(ETS-C0P1-${filenameInput}-r0-compare2ref
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_CONF}/${filenameRefSub}r0.pgx
#        -t ${TEMP}/c0${filenameInput}-r0.pgx
#        -n ${nbComponents}
#        -p ${PEAK_limit}
#        -m ${MSE_limit}
#        -s t_
#        )

#    set_tests_properties(ETS-C0P1-${filenameInput}-r0-compare2ref
#                         PROPERTIES DEPENDS
#                         ETS-C0P1-${filenameInput}-r0-decode)

#    add_test(NR-C0P1-${filenameInput}-r0-compare2base
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_NR}/opj_${filenameRefSub}-r0.pgx
#        -t ${TEMP}/c0${filenameInput}-r0.pgx
#        -n ${nbComponents}
#        -d
#        -s b_t_
#        )

#    set_tests_properties(NR-C0P1-${filenameInput}-r0-compare2base
#                         PROPERTIES DEPENDS
#                         ETS-C0P1-${filenameInput}-r0-decode)

#    #r = 3
#    add_test(ETS-C0P1-${filenameInput}-r3-decode
#        ${EXECUTABLE_OUTPUT_PATH}/opj_decompress
#        -i ${INPUT_CONF}/${filenameInput}
#        -o ${TEMP}/c0${filenameInput}-r3.pgx
#        -r 3
#        )

#    add_test(ETS-C0P1-${filenameInput}-r3-compare2ref
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_CONF}/${filenameRefSub}r3.pgx
#        -t ${TEMP}/c0${filenameInput}-r3.pgx
#        -n ${nbComponents}
#        -p ${PEAK_limit}
#        -m ${MSE_limit}
#        -s t_
#        )

#    set_tests_properties(ETS-C0P1-${filenameInput}-r3-compare2ref
#                         PROPERTIES DEPENDS
#                         ETS-C0P1-${filenameInput}-r3-decode)

#    add_test(NR-C0P1-${filenameInput}-r3-compare2base
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_NR}/opj_${filenameRefSub}-r3.pgx
#        -t ${TEMP}/c0${filenameInput}-r3.pgx
#        -n ${nbComponents}
#        -d
#        -s b_t_
#        )

#    set_tests_properties(NR-C0P1-${filenameInput}-r3-compare2base
#                         PROPERTIES DEPENDS
#                         ETS-C0P1-${filenameInput}-r3-decode)

#  else()

#    add_test(ETS-C0P1-${filenameInput}-decode
#        ${EXECUTABLE_OUTPUT_PATH}/opj_decompress
#        -i ${INPUT_CONF}/${filenameInput}
#        -o ${TEMP}/c0${filenameInput}.pgx
#        -r ${ResFactor}
#        )

#    add_test(ETS-C0P1-${filenameInput}-compare2ref
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_CONF}/${filenameRef}
#        -t ${TEMP}/c0${filenameInput}.pgx
#        -n ${nbComponents}
#        -p ${PEAK_limit}
#        -m ${MSE_limit}
#        -s t_
#        )

#    set_tests_properties(ETS-C0P1-${filenameInput}-compare2ref
#                         PROPERTIES DEPENDS
#                         ETS-C0P1-${filenameInput}-decode)

#    add_test(NR-C0P1-${filenameInput}-compare2base
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_NR}/opj_${filenameRef}
#        -t ${TEMP}/c0${filenameInput}.pgx
#        -n ${nbComponents}
#        -d
#        -s b_t_
#        )

#    set_tests_properties(NR-C0P1-${filenameInput}-compare2base
#                         PROPERTIES DEPENDS
#                         ETS-C0P1-${filenameInput}-decode)

#  endif()

#endforeach()

#--------------------------------------------------------------------------
# Tests about class 1 profile 0
# try to decode
# compare to ref file
# non regression comparison

# Parameters and tolerances given by Table C.6
set( C1P0_ResFactor_list "not_used;0;0;0;0;0;0;0;1;0;0;0;0;0;0;0;0")
set( C1P0_PEAK_list "not_used;0;0;0;5:4:6;2:2:2:0;635:403:378:0;0:0:0;0:0:0;0;0:0:0;0;0;0:0:0:0;0:0:0;0;0")
set( C1P0_MSE_list  "not_used;0;0;0;0.776:0.626:1.070;0.302:0.307:0.269:0;11287:6124:3968:0;0:0:0;0:0:0;0;0:0:0;0;0;0:0:0:0;0:0:0;0;0")

foreach(numFileC1P0 RANGE 1 16)

  # Build filenames
  if(${numFileC1P0} LESS 10)
    set( filenameInput p0_0${numFileC1P0}.j2k )
    set( filenameRef   c1p0_0${numFileC1P0}.pgx )
  else()
    set( filenameInput p0_${numFileC1P0}.j2k )
    set( filenameRef   c1p0_${numFileC1P0}.pgx )
  endif()

  # Get corresponding tests parameters
  list(GET CP0_nbC_list ${numFileC1P0}  nbComponents)
  list(GET C1P0_ResFactor_list ${numFileC1P0}  ResFactor)
  list(GET C1P0_PEAK_list ${numFileC1P0}  PEAK_limit)
  list(GET C1P0_MSE_list ${numFileC1P0}  MSE_limit)

  add_test(NAME ETS-C1P0-${filenameInput}-decode
      COMMAND opj_decompress
      -i ${INPUT_CONF}/${filenameInput}
      -o ${TEMP}/c1${filenameInput}.pgx
      -r ${ResFactor}
      )

  add_test(NAME ETS-C1P0-${filenameInput}-compare2ref
      COMMAND compare_images
     -b ${BASELINE_CONF}/${filenameRef}
     -t ${TEMP}/c1${filenameInput}.pgx
     -n ${nbComponents}
     -p ${PEAK_limit}
     -m ${MSE_limit}
     -s b_t_
     )

  set_tests_properties(ETS-C1P0-${filenameInput}-compare2ref
                       PROPERTIES DEPENDS
                       ETS-C1P0-${filenameInput}-decode)

  add_test(NAME NR-C1P0-${filenameInput}-compare2base
      COMMAND compare_images
     -b ${BASELINE_NR}/opj_${filenameRef}
     -t ${TEMP}/c1${filenameInput}.pgx
     -n ${nbComponents}
     -d
     -s b_t_
     )

  set_tests_properties(NR-C1P0-${filenameInput}-compare2base
                       PROPERTIES DEPENDS

=== tests/unit/CMakeLists.txt ===
# UNIT TESTS

include_directories(
  ${OPENJPEG_BINARY_DIR}/src/lib/openjp2 # opj_config.h
  ${OPENJPEG_SOURCE_DIR}/src/lib/openjp2
)

set(unit_test
  testempty0
  testempty1
  testempty2
)
foreach(ut ${unit_test})
  add_executable(${ut} ${ut}.c)
  target_link_libraries(${ut} openjp2)
  add_test(NAME ${ut} COMMAND ${ut})
endforeach()

add_executable(testjp2 testjp2.c)
target_link_libraries(testjp2 openjp2)
add_test(NAME testjp2 COMMAND testjp2 ${OPJ_DATA_ROOT})

=== thirdparty/libz/CMakeLists.txt ===
#based on zlib-1.2.5/CMakeLists.txt
#
cmake_minimum_required(VERSION 2.6)

project(zlib C)

string(REPLACE "-Wconversion" "" CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")
string(REPLACE "-Wsign-conversion" "" CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")

include(CheckTypeSize)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCSourceCompiles)

CHECK_INCLUDE_FILE(sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILE(stdint.h    HAVE_STDINT_H)
CHECK_INCLUDE_FILE(stddef.h    HAVE_STDDEF_H)

#
# Check to see if we have large file support
#
set(CMAKE_REQUIRED_DEFINITIONS -D_LARGEFILE64_SOURCE=1)
# We add these other definitions here because CheckTypeSize.cmake
# in CMake 2.4.x does not automatically do so and we want
# compatibility with CMake 2.4.x.
if(HAVE_SYS_TYPES_H)
    list(APPEND CMAKE_REQUIRED_DEFINITIONS -DHAVE_SYS_TYPES_H)
endif()
if(HAVE_STDINT_H)
    list(APPEND CMAKE_REQUIRED_DEFINITIONS -DHAVE_STDINT_H)
endif()
if(HAVE_STDDEF_H)
    list(APPEND CMAKE_REQUIRED_DEFINITIONS -DHAVE_STDDEF_H)
endif()
CHECK_TYPE_SIZE(off64_t OFF64_T)
if(HAVE_OFF64_T)
   add_definitions(-D_LARGEFILE64_SOURCE=1)
endif()
set(CMAKE_REQUIRED_DEFINITIONS) # clear variable
#
# Check for fseeko
#
CHECK_FUNCTION_EXISTS(fseeko HAVE_FSEEKO)
if(NOT HAVE_FSEEKO)
    add_definitions(-DNO_FSEEKO)
endif()
#
# Check for unistd.h
#
CHECK_INCLUDE_FILE(unistd.h Z_HAVE_UNISTD_H)

include_directories(
 ${CMAKE_CURRENT_SOURCE_DIR}
 ${OPENJPEG_SOURCE_DIR}/thirdparty/include
)
#
set(EXT_HDRS
 ${OPENJPEG_SOURCE_DIR}/thirdparty/include/zlib.h
 ${OPENJPEG_SOURCE_DIR}/thirdparty/include/zconf.h
)

set(HDRS
    crc32.h
    deflate.h
    gzguts.h
    inffast.h
    inffixed.h
    inflate.h
    inftrees.h
    trees.h
    zutil.h
)
set(SRCS
    adler32.c
    compress.c
    crc32.c
    deflate.c
    inflate.c
    infback.c
    inftrees.c
    inffast.c
    trees.c
    uncompr.c
    zutil.c
)

set(LIBTARGET "z")
#
add_library(${LIBTARGET} STATIC ${SRCS} ${EXT_HDRS} ${HDRS})
#
if(MSVC)
  set_target_properties(${LIBTARGET} PROPERTIES PREFIX "lib")
endif(MSVC)

set_target_properties(${LIBTARGET}
    PROPERTIES
    OUTPUT_NAME "${LIBTARGET}"
    ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/thirdparty/lib
)
#

=== src/bin/wx/OPJViewer/CMakeLists.txt ===
project(viewer CXX)

find_package(wxWidgets REQUIRED)
include(${wxWidgets_USE_FILE})

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/../..
  ${CMAKE_CURRENT_SOURCE_DIR}/..
  ${OPENJPEG_SOURCE_DIR}/src/lib
  ${OPENJPEG_SOURCE_DIR}/src/bin
  ${OPENJPEG_SOURCE_DIR}/src/lib/openjp2
  ${OPENJPEG_BINARY_DIR}/src/lib/openjp2 # opj_config.h and opj_config_private.h
  )

# original flags:
# -DUSE_JPWL -DwxUSE_LIBOPENJPEG -DwxUSE_GUI=1 -DOPJ_STATIC -DOPJ_HTMLABOUT -DOPJ_INICONFIG -DUSE_JPSEC -DOPJ_MANYFORMATS
add_definitions(-DwxUSE_LIBOPENJPEG -DOPENJPEG_VERSION="1.5.0")
set(OPJV_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/source/imagjpeg2000.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/wxj2kparser.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/OPJViewer.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/wxjp2parser.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/OPJDialogs.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/OPJThreads.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/OPJAbout.cpp
  ${OPENJPEG_SOURCE_DIR}/src/bin/jp2/index.c
  )
add_executable(opjviewer ${OPJV_SRCS})
target_link_libraries(opjviewer ${wxWidgets_LIBRARIES} openjpeg)

=== debian/changelog ===
openjpeg2 (2.5.3-2ubuntu0.1) plucky-security; urgency=medium

  * SECURITY UPDATE: use of uninitialized variable
    - debian/patches/CVE-2025-54874.patch: Check for error after parsing
      header in src/lib/openjp2/jp2.c.
    - CVE-2025-54874

 -- Edwin Jiang <edwin.jiang@canonical.com>  Wed, 17 Sep 2025 19:03:07 +0000

openjpeg2 (2.5.3-2) unstable; urgency=medium

  * Team upload.
  * Drop libopenjpip-server to make libfcgi a non-key pkg, see: #1092774.

 -- Bastian Germann <bage@debian.org>  Mon, 10 Mar 2025 08:22:54 +0100

openjpeg2 (2.5.3-1) unstable; urgency=medium

  * Team upload.
  * No-change rebuild for unstable.

 -- Santiago Ruano Rincón <santiagorr@riseup.net>  Fri, 31 Jan 2025 15:25:25 -0300

openjpeg2 (2.5.3-1~exp2) experimental; urgency=medium

  * Team upload.
  * Move doxygen from Build-Dep to Build-Depends-Indep
  * Override dh_missing to make it list the missing files

 -- Santiago Ruano Rincón <santiagorr@riseup.net>  Tue, 28 Jan 2025 16:53:29 -0300

openjpeg2 (2.5.3-1~exp1) experimental; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * New upstream version
    Closes: #1089596
  * Standards-Version: 4.7.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * d/rules: Do not parse d/changelog
  * Do not parse d/changelog (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * watch file standard 4 (routine-update)
  * Solve openjpeg / apache build-dep loop
    Closes: #1055436

  [ Santiago Ruano Rincón ]
  * Add doxygen as Build-Dep
  * Install doc related files in openjpeg-doc
  * Update d/copyright

 -- Santiago Ruano Rincón <santiagorr@riseup.net>  Mon, 27 Jan 2025 15:05:10 -0300

=== debian/control ===
Source: openjpeg2
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Mathieu Malaterre <malat@debian.org>
Section: libs
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-apache2 <!pkg.openjpeg2.noapache>,
               help2man,
               liblcms2-dev,
               libpng-dev,
               libtiff-dev,
               zlib1g-dev
Build-Depends-Indep: default-jdk,
                     doxygen,
                     javahelper,
                     libxerces2-java
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/openjpeg2
Vcs-Git: https://salsa.debian.org/debian-phototools-team/openjpeg2.git
Homepage: https://www.openjpeg.org
Rules-Requires-Root: no

Package: libopenjp2-7-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libopenjp2-7 (= ${binary:Version}),
         ${misc:Depends}
Description: development files for OpenJPEG, a JPEG 2000 image library
 OpenJPEG is a library for handling the JPEG 2000 image compression format.
 JPEG 2000 is a wavelet-based image compression standard and permits progressive
 transmission by pixel and resolution accuracy for progressive downloads of an
 encoded image. It supports lossless and lossy compression, supports higher
 compression than JPEG 1991, and has resilience to errors in the image.
 .
 This package contains the development files for openjpeg 2.x

Package: libopenjp2-7
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: JPEG 2000 image compression/decompression library
 OpenJPEG is a library for handling the JPEG 2000 image compression format.
 JPEG 2000 is a wavelet-based image compression standard and permits progressive
 transmission by pixel and resolution accuracy for progressive downloads of an
 encoded image. It supports lossless and lossy compression, supports higher
 compression than JPEG 1991, and has resilience to errors in the image.
 .
 This package contains the runtime files for openjpeg 2.x

Package: openjpeg-doc
Architecture: all
Section: doc
Depends: doc-base,
         ${misc:Depends}
Description: JPEG 2000 image compression/decompression library
 OpenJPEG is a library for handling the JPEG 2000 image compression format.
 JPEG 2000 is a wavelet-based image compression standard and permits progressive
 transmission by pixel and resolution accuracy for progressive downloads of an
 encoded image. It supports lossless and lossy compression, supports higher
 compression than JPEG 1991, and has resilience to errors in the image.
 .
 This package installs the documentation files.

Package: libopenjpip7
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: JPEG 2000 Interactive Protocol
 OpenJPEG is a library for handling the JPEG 2000 image compression format.
 JPEG 2000 is a wavelet-based image compression standard and permits progressive
 transmission by pixel and resolution accuracy for progressive downloads of an
 encoded image. It supports lossless and lossy compression, supports higher
 compression than JPEG 1991, and has resilience to errors in the image.
 .
 This is an implementation of the JPEG 2000 Interactive Protocol (Part-9)

Package: libopenjpip-dec-server
Architecture: any
Multi-Arch: foreign
Section: graphics
Depends: ${misc:Depends},
         ${shlibs:Depends}
Conflicts: openjpip-dec-server
Description: tool to allow caching of JPEG 2000 files using JPIP protocol
 This is client side application for caching remote JPEG 2000 using the JPIP
 protocol. This command line application needs to run on the client side to
 allow application such as opj_viewer to view images.

Package: libopenjpip-viewer
Architecture: all
Build-Profiles: <!pkg.openjpeg2.noapache>
Section: graphics
Depends: libopenjpip-dec-server,
         ${java:Depends},
         ${misc:Depends}
Suggests: libopenjp2-tools
Conflicts: openjpip-viewer
Description: JPEG 2000 java based viewer for advanced remote JPIP access
 Java based client to view remote JPEG 2000 using JPIP protocol.
 This is a simple java viewer to allow:
 .
  - Scale up request: Enlarge the window
  - ROI request: Select a region by mouse click and drag, then click inside the
    red frame of the selected region
  - Annotate image with ROI information in XML metadata: Click button "Region
    Of Interest"
  - Open a new window presenting an aligned image with a locally stored image:
    Click button "Image Registration" (Under Construction)

Package: libopenjp2-tools
Architecture: any
Multi-Arch: foreign
Section: graphics
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: command-line tools using the JPEG 2000 library
 This package provides with command-line tools allowing for conversions between
 several formats and also provides tools for encoding and decoding
 motion-jpeg2000 video formats:
 .
  - opj_decompress: decodes j2k, jp2, and jpt files to pgm, ppm, pnm,
                  pgx, and bmp.
  - opj_compress: encodes pnm, pgm, pgx, bmp, and ppm files to j2k,
                  and jp2.
  - opj_dump: dump information contains in j2k and jp2.
  - index_create: create jp2 with JPIP index file from a j2k file.
  - frames_to_mj2: convert YUV video streams to mj2 format.
  - mj2_to_frames: convert mj2 video streams to YUV format.
  - wrap_j2k_in_mj2: wrap j2k codestreams into mj2 format.
  - extract-j2k-from_mj2: extract j2k codestreams from the mj2 format.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# as per upstream request:
export DEB_CFLAGS_MAINT_APPEND = -fvisibility=hidden

# deduce documentation option (build-indep target)
ifeq "" "$(filter %-doc,$(shell dh_listpackages))"
  BUILDDOC = OFF
else
  BUILDDOC = ON
endif

ifeq (,$(filter pkg.openjpeg2.noapache,$(DEB_BUILD_PROFILES)))
DH_APACHE=--with=apache2
endif

%:
	dh $@ $(DH_APACHE) $(DH_ADDONS)
build binary %-indep: DH_ADDONS=--with=javahelper

CMAKE_EXTRA_FLAGS += -DCMAKE_SKIP_RPATH=ON \
  -DCMAKE_BUILD_TYPE:STRING=None \
  -DOPENJPEG_INSTALL_LIB_DIR:STRING=lib/$(DEB_HOST_MULTIARCH) \
  -DBUILD_CODEC:BOOL=ON \
  -DBUILD_JPIP:BOOL=ON \
  -DBUILD_JPIP_SERVER:BOOL=OFF \
  -DBUILD_JPWL:BOOL=OFF \
  -DBUILD_JAVA:BOOL=OFF \
  -DBUILD_MJ2:BOOL=OFF \
  -DBUILD_JP3D:BOOL=ON \
  -DBUILD_SHARED_LIBS:BOOL=ON \
  -DBUILD_STATIC_LIBS:BOOL=ON \
  -DBUILD_TESTING:BOOL=OFF \
  -DBUILD_DOC:BOOL=$(BUILDDOC) \
  -DBUILD_THIRDPARTY:BOOL=OFF

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

SOVERSION=7
pkg_lib = libopenjp2-$(SOVERSION)
pkg_dev = libopenjp2-$(SOVERSION)-dev
pkg_doc = openjpeg-doc
pkg_bin = libopenjp2-tools
pkg_jpip = libopenjpip$(SOVERSION)
pkg_vwr = libopenjpip-viewer
pkg_dsrv = libopenjpip-dec-server

override_dh_install-arch:
	# annoying cmake-fatal-error export stuff:
	sed -i -e "s/FATAL_ERROR/STATUS/g" debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/openjpeg-2.5/OpenJPEGTargets*.cmake
	# install opj_dump/compress/decompress:
	dh_install -p$(pkg_bin) --autodest -Xserver -Xjpip usr/bin/*
	dh_install -p$(pkg_bin) --autodest -Xserver -Xjpip usr/share/man/man1/*.1
	# lib
	dh_install -p$(pkg_lib) --autodest usr/lib/$(DEB_HOST_MULTIARCH)/libopenjp2.so.*
	# dev:
	dh_install -p$(pkg_dev) --autodest usr/lib/$(DEB_HOST_MULTIARCH)/libopenjp2.a
	dh_install -p$(pkg_dev) --autodest usr/lib/$(DEB_HOST_MULTIARCH)/libopenjp2.so
	# Do not install .so symblink for now:
	#dh_install -p$(pkg_dev) --autodest usr/lib/$(DEB_HOST_MULTIARCH)/libopenjpip.so
	dh_install -p$(pkg_dev) --autodest usr/lib/$(DEB_HOST_MULTIARCH)/cmake/openjpeg-2.5/*.cmake
	dh_install -p$(pkg_dev) --autodest usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/*.pc
	dh_install -p$(pkg_dev) --autodest usr/include/openjpeg-2.5
	dh_install -p$(pkg_dev) --autodest usr/share/man/man3/libopenjp2.3
	dh_install -p$(pkg_dev) --autodest usr/lib/$(DEB_HOST_MULTIARCH)/libopenjpip.so
	# accept hardcoded path to 2.1 (2.5 kept the same SONAME):
	dh_link -p$(pkg_dev) usr/lib/$(DEB_HOST_MULTIARCH)/openjpeg-2.5 usr/lib/$(DEB_HOST_MULTIARCH)/openjpeg-2.1
	dh_link -p$(pkg_dev) usr/include/openjpeg-2.5 usr/include/openjpeg-2.1
	# libjpip:
	dh_install -p$(pkg_jpip) --autodest usr/lib/$(DEB_HOST_MULTIARCH)/libopenjpip.so.*
	# dec-server
	dh_install -p$(pkg_dsrv) --autodest usr/bin/opj_dec_server
	dh_install -p$(pkg_dsrv) --autodest usr/bin/opj_jpip*
	dh_install

include /usr/share/dpkg/default.mk

# create man pages:
export LD_LIBRARY_PATH := $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/:$(LD_LIBRARY_PATH)
export PATH := $(CURDIR)/debian/tmp/usr/bin:$(PATH)

include /usr/share/dpkg/default.mk

debian/%.1: debian/opj_common.1.in
	help2man --include=$< --output=$@ --name="Works with JPEG2000 files" \
		--no-info --no-discard-stderr `basename $@ .1` --help-option=-h --version-string=$(DEB_VERSION_UPSTREAM)

opj_manpages: debian/opj_jpip_addxml.1 debian/opj_jpip_test.1 debian/opj_jpip_transcode.1
	echo "all missing man pages done"

# never returns:
# debian/opj_dec_server.1 debian/opj_jpip_viewer.1

override_dh_installman: opj_manpages
	dh_installman -p$(pkg_dsrv) debian/opj_jpip_*.1
	#dh_installman -p$(pkg_vwr) debian/opj_dec_server.1
	#dh_installman

# I don't find it *trivial* to build and install -arch or -indep files. E.g.
# open opj_jpip_viewer.jar is to be installed in an _all package, while it
# needs to be built along with the C library.
override_dh_missing-indep:
	dh_missing -i --list-missing

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/openjpeg-$1\.tar\.gz/ \
  https://github.com/uclouvain/openjpeg/tags .*/v?(\d\S*)\.tar\.gz

## openjpeg2 2.5.4

=== debian/changelog ===
openjpeg2 (2.5.4-1) unstable; urgency=medium

  * Team upload.
  * add debian/gbp.conf
  * New upstream version 2.5.4
  * Bump Standards-Version: 4.7.3
  * d/control: update openjpeg-doc package short-description
  * d/copyright:
      - remove Files-Excluded field, useless
      - update-debian-copyright to 2026
  * symbols file add Build-Depends-Package: libopenjp2-7-dev
  * d/rules: add export DEB_BUILD_MAINT_OPTIONS = hardening=+all
  * add d/p/fix-typo-man-libopenjp2.patch
  * delete patch which new upstream applied:
    d/p/0001-opj_jp2_read_header-Check-for-error-after-parsing-he.patch

 -- xiao sheng wen <atzlinux@debian.org>  Wed, 07 Jan 2026 11:28:57 +0800

openjpeg2 (2.5.3-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * CVE-2025-54874: Out-of-bounds write in opj_jp2_read_header()
    (Closes: #1110443)

 -- Adrian Bunk <bunk@debian.org>  Sat, 09 Aug 2025 18:19:52 +0300

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: openjpeg2
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
+Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders: Mathieu Malaterre <malat@debian.org>
 Section: libs
 Priority: optional
@@ -16,7 +15,7 @@
                      doxygen,
                      javahelper,
                      libxerces2-java
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/openjpeg2
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/openjpeg2.git
 Homepage: https://www.openjpeg.org
@@ -57,7 +56,7 @@
 Section: doc
 Depends: doc-base,
          ${misc:Depends}
-Description: JPEG 2000 image compression/decompression library
+Description: JPEG 2000 image compression/decompression library documentation
  OpenJPEG is a library for handling the JPEG 2000 image compression format.
  JPEG 2000 is a wavelet-based image compression standard and permits progressive
  transmission by pixel and resolution accuracy for progressive downloads of an

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,7 @@
 #!/usr/bin/make -f
 #export DH_VERBOSE=1
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
